/* ------------------------------------------------------------------------- */
/*
 *  syntax_error.h
 *
 *  Copyright (c) 2004 - 2007 "clown". All rights reserved.
 *
 *  Permission to copy, use, modify and distribute this software is
 *  granted provided this copyright notice appears in all copies.
 *  This software is provided "as is" without express or implied
 *  warranty, and with no claim as to its suitability for any purpose.
 *
 *  Last-modified: Fri 16 Mar 2007 17:52:03 JST
 */
/* ------------------------------------------------------------------------- */
#ifndef CLX_SYNTAX_ERROR_H
#define CLX_SYNTAX_ERROR_H

#include <stdexcept>
#include <string>

namespace clx {
	/* --------------------------------------------------------------------- */
	//  syntax_error
	/* --------------------------------------------------------------------- */
	class syntax_error : public std::runtime_error {
	public:
		typedef unsigned int size_type;
		typedef char char_type;
		typedef std::string string_type;
		
		explicit syntax_error(size_type n, const string_type& what_arg) :
			std::runtime_error(what_arg), line_(n) {}
		
		size_type line() { return line_; }
		
	private:
		size_type line_;
	};
}

#endif // CLX_SYNTAX_ERROR_H
