/* ------------------------------------------------------------------------- */
/*
 *  winsock_util.h
 *
 *  Copyright (c) 2004 - 2008 "clown". All rights reserved.
 *
 *  Permission to copy, use, modify and distribute this software is
 *  granted provided this copyright notice appears in all copies.
 *  This software is provided "as is" without express or implied
 *  warranty, and with no claim as to its suitability for any purpose.
 *
 *  Last-modified: Fri 08 Feb 2008 01:23:00 JST
 */
/* ------------------------------------------------------------------------- */
#ifndef CLX_WINSOCK_UTIL_H
#define CLX_WINSOCK_UTIL_H

#include <winsock2.h>
#pragma comment(lib, "ws2_32.lib")

/* ------------------------------------------------------------------------- */
/*
 *  inet_aton
 *
 *  WinSock does not have the inet_aton() function.
 */
/* ------------------------------------------------------------------------- */
int inet_aton(const char* s, struct in_addr* addr) {
	int tmp = ::inet_addr(s);
	if (tmp != INADDR_NONE || ::strcmp(s, "255.255.255.255") == 0) {
		if (addr) addr->s_addr = tmp;
		return 1;
	}
	return 0;
}

namespace clx {
	/* --------------------------------------------------------------------- */
	//  winsock_init
	/* --------------------------------------------------------------------- */
	class winsock_init {
	public:
		winsock_init() {
			WSADATA dat;
			::WSAStartup(MAKEWORD(2, 0), &dat);
		}
		
		~winsock_init() {
			::WSACleanup();
		}
	private:
		explicit winsock_init(const winsock_init& cp);
		winsock_init& operator=(const winsock_init& cp);
	};
	
	static winsock_init ws_init_;
}

#endif // CLX_WINSOCK_UTIL_H
